//---------------------------------------------------------------------------

#include <vcl.h>

#pragma hdrstop

#include "SpeedDialPanel.h"
#include <assert.h>
#pragma package(smart_init)
//---------------------------------------------------------------------------
// ValidCtrCheck is used to assure that the components created do not have
// any pure virtual functions.
//

static inline void ValidCtrCheck(TSpeedDialPanel *)
{
	new TSpeedDialPanel(NULL, new TImageList(NULL));
}
//---------------------------------------------------------------------------
__fastcall TSpeedDialPanel::TSpeedDialPanel(TComponent* Owner, TImageList* imgList)
	: TPanel(Owner), imgList(imgList), state(DIALOG_INFO_UNKNOWN)
{
	assert(imgList);
	
	OnMouseEnter = MouseEnter;
	OnMouseLeave = MouseLeave;

	label = new TLabel(this);
	label->Parent = this;
	label->Left = 20;
	label->Top = 8;
	label->OnMouseEnter = MouseEnter;
	label->OnMouseLeave = MouseLeave;

	image = new TImage(this);
	image->Parent = this;
	image->Left = 2;
	image->Top = 8;
	image->Width = 16;
	image->Height = 16;
	image->Picture->Bitmap->PixelFormat = pf24bit;
	image->Transparent = true;
	SetState(DIALOG_INFO_UNKNOWN);	
	image->OnMouseEnter = MouseEnter;
	image->OnMouseLeave = MouseLeave;
}
//---------------------------------------------------------------------------
namespace Speeddialpanel
{
	void __fastcall PACKAGE Register()
	{
		TComponentClass classes[1] = {__classid(TSpeedDialPanel)};
		RegisterComponents("Samples", classes, 0);
	}
}
//---------------------------------------------------------------------------

void __fastcall TSpeedDialPanel::MouseEnter(TObject *Sender)
{
	BevelOuter = bvLowered;
}

void __fastcall TSpeedDialPanel::MouseLeave(TObject *Sender)
{
	BevelOuter = bvRaised;
}

void TSpeedDialPanel::SetDescription(AnsiString text)
{
	label->Caption = text;
}

void TSpeedDialPanel::UpdateCallbacks(void)
{
	image->OnClick = OnClick;
	label->OnClick = OnClick;

	image->OnDblClick = OnDblClick;
	label->OnDblClick = OnDblClick;
}

void TSpeedDialPanel::SetState(enum dialog_info_status state)
{
	this->state = state;
	image->Picture = NULL;	// clear picture
	image->Picture->Bitmap->PixelFormat = pf24bit;
	switch (state)
	{
	case DIALOG_INFO_TERMINATED:
		imgList->GetBitmap(1, image->Picture->Bitmap);
		break;
	case DIALOG_INFO_EARLY:
		imgList->GetBitmap(2, image->Picture->Bitmap);
		break;
	case DIALOG_INFO_CONFIRMED:
		imgList->GetBitmap(3, image->Picture->Bitmap);
		break;
	default: // DIALOG_INFO_UNKNOWN included
		imgList->GetBitmap(0, image->Picture->Bitmap);
	}
}

